{% extends "template/app.twig" %}

{% block meta %}
    {% set meta = {'keywords': 'Ventas'} %}
    {{ parent() }}
{% endblock %}

{% block link %}
    {{ parent() }}
{% endblock %}

{% block header %}
    {{ parent() }}
{% endblock %}

{% block aside %}
    {{ parent() }}
{% endblock %}

{% block content %}
    {{ parent() }}
    {% include "template/partial/section/sale_edit.twig" %}
{% endblock %}

{% block footer %}
    {{ parent() }}
{% endblock %}

{% block script %}
    {{ parent() }}

    <script>
        $(document).ready(function () {

            $(".sf-ve").click(function () {
                var json = objectifyForm($('#form-ve').serializeArray());

                /////////

                $.ajax({
                    type: "PUT",
                    url: "../editarVenta/{{opportunity.opportunity_id}}",
                    data: json,
                    dataType: "JSON",
                    success: function (data) {
                        console.log(data);
                        notify('Informacion registrada correctamente!', 'success');
                    },
                    error: function (data) {
                        console.log(data);

                        notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                    }
                });

            });

            /******************************************************************/

            $(".sf-anve").click(function () {
                var total = $("#total_cont_seri").val();
                var usuario = "{{user_id}}";

                //VALIDAR SEGURIDAD: modificar par aun grupo de usuarios

                if (total > 0 && usuario != "6") {
                    swal("Acción no permitida", "No puede anular la venta, esta ya tiene seriales/contratos asignados.", "warning");
                } else {
                    $('#anularVenta').modal('show');
                }
            });

            /******************************************************************/

            $(".vereverse").click(function () {
                if ($("#milestone_title").val() == "") {
                    notify('Campo Titulo es requerido!', 'warning');
                    $(".fopc1Has").addClass("has-warning");
                    return false;
                } else {
                    $(".fopc1Has").removeClass("has-warning");
                }

                /*if ($("#milestone_detail").val() == "") {
                    notify('Campo Detalle es requerido!', 'warning');
                    $(".fopc2Has").addClass("has-warning");
                    return false;
                } else {
                    $(".fopc2Has").removeClass("has-warning");
                }*/

                if ($("#milestone_date").val() == "") {
                    notify('Campo Fecha es requerido!', 'warning');
                    $(".fopc3Has").addClass("has-warning");
                    return false;
                } else {
                    $(".fopc3Has").removeClass("has-warning");
                }

                if ($("#milestone_status").val() == "") {
                    notify('Campo Estado es requerido!', 'warning');
                    $(".fopc4Has").addClass("has-warning");
                    return false;
                } else {
                    $(".fopc4Has").removeClass("has-warning");
                }


                var json = objectifyForm($('#form-reve').serializeArray());

                //alert(JSON.stringify(json));

                /////////

                $.ajax({
                    type: "PUT",
                    url: "../reversarVenta/{{opportunity.opportunity_id}}",
                    data: json,
                    dataType: "JSON",
                    success: function (data) {
                        console.log(data);
                        $("#anularVenta").modal('hide');

                        swal("Venta Anulada", "Volviendo al listado...", "success");

                        setTimeout(function () {
                            window.location.href = "../listado";
                        }, 2000);
                    },
                    error: function (data) {
                        console.log(data);

                        notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                    }
                });
            });

            /******************************************************************/

            $(".sf-serial").click(function () {
                var id_sc = $(this).data("value");
                var brand = $("#brand_id_id").val();

                var type = $("#serial_type" + id_sc).val();
                var numero = $("#serial_number" + id_sc).val();
                var vencimiento = $("#serial_enddate" + id_sc).val();
                var limite = $("#serial_limitdate" + id_sc).val();
				
                var id_detail_serial = $("#id_detail_serial" + id_sc).val();
                var sku_serial = $("#sku_serial" + id_sc).val();
				
				var rSC = $("#serial_number" + id_sc).data("required");
				var rED = $("#serial_enddate" + id_sc).data("required");
				var rLD = $("#serial_limitdate" + id_sc).data("required");
				
				if(rSC=="1"){
					if ($("#serial_number" + id_sc).val() == "") {
						notify('Campo Número Serial es requerido!', 'warning');
						return false;
					}
				}
				if(rED=="1"){
					if ($("#serial_enddate" + id_sc).val() == "") {
						notify('Campo Vencimiento es requerido!', 'warning');
						return false;
					}
				}
				if(rLD=="1"){
					if ($("#serial_limitdate" + id_sc).val() == "") {
						notify('Campo Fecha Registro es requerido!', 'warning');
						return false;
					}
				}
				
				
                /*if ($("#serial_number" + id_sc).val() == "") {
                    notify('Campo Número Serial es requerido!', 'warning');
                    return false;
                }

                if (brand == 1) {
                    if (type != "HARD") {
                        if ($("#serial_enddate" + id_sc).val() == "") {
                            //notify('Campo Vencimiento es requerido!', 'warning');
                            //return false;
                        }
                    }

                    if ($("#serial_limitdate" + id_sc).val() == "") {
                        //notify('Campo Fecha Registro es requerido!', 'warning');
                        //return false;
                    }
                }*/
                //alert(JSON.stringify(json));
                /////////

                $.ajax({
                    type: "PUT",
                    url: "../registrarSerial/" + id_sc,
                    data: {serials_contract_number: numero, serials_contract_enddate: vencimiento, serials_contract_limitdate: limite, sku:sku_serial, id_detail:id_detail_serial},
                    dataType: "JSON",
                    success: function (data) {
                        console.log(data);

                        if (data == "OK") {
                            $("#error" + id_sc).html("");
                            notify('Informacion registrada correctamente!', 'success');
                        }
                        if (data == "VALIDACION") {
                            $("#error" + id_sc).html("Número de serial #" + numero + " ya registrado");
                            notify('Ya existe el número de serial!', 'warning');
                        }
						
						if(sku_serial=="FTNT-COT"){
							setTimeout(function () {
                                window.location.reload();
                            }, 1000);
						}
                    },
                    error: function (data) {
                        console.log(data);
                        notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                    }
                });
            });

            /******************************************************************/


            $(".csadm-serial").click(function () {
                var id_sc = $(this).data("value");
                var status = $(this).data("status");

                /////////

                $.ajax({
                    type: "PUT",
                    url: "../confirmarEstado/" + id_sc,
                    data: {serials_contract_status: status},
                    dataType: "JSON",
                    success: function (data) {
                        console.log(data);

                        if (data == "OK") {
                            $("#error" + id_sc).html("");
                            notify('Informacion registrada correctamente!', 'success');

							setTimeout(function () {
                                window.location.reload();
                            }, 1000);
                        }else{
                            $("#error" + id_sc).html(data);
                            notify('Ha ocurrido un error registrando el estado!', 'warning');
                        }
                    },
                    error: function (data) {
                        console.log(data);
                        notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                    }
                });
            });

            /******************************************************************/

            $("body").on('click', '.sf-contrato', function () {
                var deid = $(this).data("value");
                var brand = $("#brand_id_id").val();

                if ($("#contrat_number" + deid).val() == "") {
                    notify('Campo Número contrato es requerido!', 'warning');
                    return false;
                }

                if (brand == 1) {
                    if ($("#contrat_limit" + deid).val() == "") {
                        //notify('Campo Limite Registro es requerido!', 'warning');
                        //return false;
                    }
                }

                var numero = $("#contrat_number" + deid).val();
                var limite = $("#contrat_limit" + deid).val();
                var parent = $("#contract_parent" + deid).val();
                var sku_ = $("#sku").val();
                var opdeid = $("#opdeid" + deid).val();
				
                var edit_id_contract = $("#edit_id_contract" + deid).val();

                /////////
				
				if(edit_id_contract=="0"){
					$.ajax({
						type: "POST",
						url: "../registrarContrato/" + opdeid,
						data: {
						  "sku": sku_,
						  "serials_contract_number": numero,
						  "serials_contract_limitdate": limite,
						  "serials_contract_parent": parent
						},
						dataType: "JSON",
						success: function (data) {
							console.log(data);

							if (data == "OK") {
								$("#errorc" + deid).html("");
								notify('Informacion registrada correctamente!', 'success');

								setTimeout(function () {
									window.location.reload();
								}, 1000);
							}
							if (data == "VALIDACION") {
								$("#errorc" + deid).html("Número de contrato ya registrado");
								notify('Ya existe el número de contrato!', 'warning');
							}
						},
						error: function (data) {
							console.log(data);
							notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
						}
					});
				}else{
					$.ajax({
						type: "POST",
						url: "../editarContrato/" + edit_id_contract,
						data: {
							serials_contract_number: numero,
							serials_contract_limitdate: limite
						},
						dataType: "JSON",
						success: function (data) {
							console.log(data);

							if (data == "OK") {
								$("#errorc" + deid).html("");
								notify('Informacion registrada correctamente!', 'success');

								setTimeout(function () {
									window.location.reload();
								}, 1000);

							}
							if (data == "FAIL") {
								notify('No se pudo editar!', 'warning');
							}
						},
						error: function (data) {
							console.log(data);
							notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
						}
					});
				}
            });

			/******************************************************************/

            $("body").on('click', '.sf-contrato-edit', function () {
                var sc_id = $(this).data("value");
                var number = $('#contrat_number_children'+sc_id).val();
                var date_end = $('#contrat_limit_children'+sc_id).val();
				var sc_idc = $('#scid_children'+sc_id).val();

				if (number == "" || number=="###") {
					notify('Campo numero contrato es requerido!', 'warning');
					return false;
				}

                $.ajax({
                    type: "POST",
                    url: "../editarContrato/" + sc_idc,
                    data: {
                        serials_contract_number: number,
                        serials_contract_limitdate: date_end
                    },
                    dataType: "JSON",
                    success: function (data) {
                        console.log(data);

                        if (data == "OK") {
                            $("#errorc" + sc_id).html("");
                            notify('Informacion registrada correctamente!', 'success');

                            setTimeout(function () {
                                window.location.reload();
                            }, 1000);

                        }
                        if (data == "FAIL") {
                            //$("#errorc" + deid).html("");
                            notify('No se pudo editar!', 'warning');
                        }
                    },
                    error: function (data) {
                        console.log(data);
                        notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                    }
                });
            });

            /******************************************************************/

            $(".del-scid").click(function () {
                var id_sc = $(this).data("value");

                swal({
                    title: "Está seguro de eliminar el contrato?",
                    text: "Se eliminará dela venta!",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: "Si, eliminar!",
                    cancelButtonText: "No, cancelar",
                    closeOnConfirm: false
                }, function (isConfirm) {
                    if (isConfirm) {

                        $.ajax({
                            type: "DELETE",
                            url: "../eliminarContrato/",
                            data: {serials_contract_id: id_sc},
                            dataType: "JSON",
                            success: function (data) {
                                console.log(data);

                                $("#contract_list_" + id_sc).fadeOut();

                                swal.close();
                                notify('Contrato eliminado!', 'success');
                            },
                            error: function (data) {
                                console.log(data);
                                notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                            }
                        });
                    }
                });

            });

            /******************************************************************/

            /******************************************************************/
            $(".edit-scid").click(function () {
                var sc_id_children = $(this).data("value");
				var parent_children = $(this).data("parent");

                var number = $("#contract_children_" + sc_id_children).val();
				if(number==""){ number = "###"; }
                var date_end = $("#date_end_children_" + sc_id_children).val();

                $("#up_or_edit_children" + parent_children).show();

                $('#contrat_number_children' + parent_children).val(number);
                $('#contrat_limit_children' + parent_children).val(date_end);
                $('#scid_children' + parent_children).val(sc_id_children);

            });
            /******************************************************************/
			
			$(".edit-scidparent").click(function () {
				var sc_id_parent = $(this).data("value");
                var contract_parent_id = $("#contract_parent_" + sc_id_parent).val();

                var number = $("#contract_" + sc_id_parent).val();
				if(number==""){ number = "###"; }
                var date_end = $("#date_end_" + sc_id_parent).val();
				var formato = date_end.split("-");
				date_end = formato[2]+"/"+formato[1]+"/"+formato[0];

                $('#contrat_number' + contract_parent_id).val(number);
                $('#contrat_limit' + contract_parent_id).val(date_end);
				
                $('#edit_id_contract' + contract_parent_id).val(sc_id_parent);
				
				$("#up_or_edit" + contract_parent_id).html('<i class="zmdi zmdi-edit"></i> Editar');			

            });
            /******************************************************************/

        });
    </script>
{% endblock %}
